SystemOrganization addCategory: #'LegoIR-Core'!

Object subclass: #LegoIRTower
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LegoIR-Core'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:37'!
connectOnPort: aString 
port := SerialPort new baudRate: 115200.
port := port
				openPort: (('COM*' match: aString)
						ifTrue: [aString asInteger]
						ifFalse: [aString]).
self isConnected ifFalse: [^self error: 'Port not connected']! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:40'!
disconnect
port close.
port := nil! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:39'!
isConnected
	^port notNil! !

!LegoIRTower methodsFor: 'sending' stamp: 'Richo 10/13/2010 14:48'!
send: hexCode noWakeUp: cero
| numberOfTxBytes list |
self isConnected ifFalse: [^self error: 'Not connected'].
numberOfTxBytes := 8.
list := OrderedCollection new.
8 * numberOfTxBytes timesRepeat: [list add: 0].
(hexCode printStringBase: 2)
	do: [:bit |
	bit = $1 ifTrue: [5 * numberOfTxBytes timesRepeat: [list add: 255]]
ifFalse: [numberOfTxBytes timesRepeat: [list add: 255]].
numberOfTxBytes timesRepeat: [list add: 0]
	].
port nextPutAll: list asByteArray

! !
